#include <string>
#include <admin>
#include <adminlib>

new STRING_VERSION[MAX_DATA_LENGTH] = "0.80";

#define MAX_LOADED	10
new g_File[]="addons/adminmod/config/banip_range.cfg";
new g_BanFile[]="addons/adminmod/config/banip_log.cfg";
new g_loaded;
new g_IP_Range_A[MAX_LOADED];
new g_IP_Range_B[MAX_LOADED];
new g_IP_Range_C[MAX_LOADED];
new g_IP_Range_D[MAX_LOADED];

new g_Spec[MAX_PLAYERS];

forward seperate_ip(IP[],&iA,&iB,&iC,&iD);

public plugin_init() {
	plugin_registerinfo("Ban IP Range","Ban IP Range Class A,B,C with *",STRING_VERSION);
	plugin_registercmd("specmode","specmode",ACCESS_ALL);
	read_file();
	return PLUGIN_CONTINUE;
}

read_file(){
	new Text[MAX_TEXT_LENGTH];
	new Data[MAX_DATA_LENGTH];
	new i;
	new iFileSize;

	if(fileexists(g_File)){
		iFileSize=filesize(g_File);
		if(iFileSize>=MAX_LOADED){
			selfmessage("[BAN_IP_RANGE] Sorry. To many entries in file. Increase #define MAX_LOADED in *.sma file and recompile!");
			iFileSize=MAX_LOADED-1;
		}
		for(i=1;i<=iFileSize;i++){
			readfile(g_File,Data,i,MAX_AUTHID_LENGTH);
			seperate_ip(Data,g_IP_Range_A[g_loaded],g_IP_Range_B[g_loaded],g_IP_Range_C[g_loaded],g_IP_Range_D[g_loaded]);
			g_loaded++;
		}
		g_loaded--;
		snprintf(Text,MAX_TEXT_LENGTH,"[BAN_IP_RANGE] %i entries loaded from %s",g_loaded+1,g_File);
		selfmessage(Text);
	}else{
		snprintf(Text,MAX_TEXT_LENGTH,"[BAN_IP_RANGE] Sorry. File not found: %s",g_File);
		selfmessage(Text);
	}
}

public plugin_connect(HLUserName,HLIP, UserIndex) {
	g_Spec[UserIndex]=0;
}

public plugin_disconnect(HLUserName,UserIndex) {
	g_Spec[UserIndex]=0;
}

public specmode(HLCommand,HLData,HLUserName,UserIndex) {
	if(!g_Spec[UserIndex]){
		g_Spec[UserIndex]=1;
		check_ip(UserIndex);
	}
	return PLUGIN_CONTINUE;
}

check_ip(UserIndex){
	new Text[MAX_TEXT_LENGTH];
	new User[MAX_NAME_LENGTH];
	new IP[MAX_AUTHID_LENGTH];
	new SteamID[MAX_AUTHID_LENGTH];
	new ST[MAX_DATA_LENGTH];
	new Status[MAX_NAME_LENGTH];
	new i;
	new found;
	new A_Range;
	new B_Range;
	new C_Range;
	new D_Range;
	
	servertime(ST, MAX_DATA_LENGTH, "%d.%m.%y %H:%M:%S");
	
	if(playerinfo(UserIndex,User,MAX_NAME_LENGTH,_,_,_,_,SteamID)){
		get_userIP(User,IP,MAX_AUTHID_LENGTH);
		seperate_ip(IP,A_Range,B_Range,C_Range,D_Range);
		for(i=0;i<=g_loaded;i++){
			if(A_Range==g_IP_Range_A[i]){
				if(g_IP_Range_B[i]==-1){
					snprintf(Text,MAX_TEXT_LENGTH,"Your IP %s is in range of %i.*.*.* -> BANNED!",IP,g_IP_Range_A[i]);
					found=1;
					break;
				}else if(B_Range==g_IP_Range_B[i]){
					if(g_IP_Range_C[i]==-1){
						snprintf(Text,MAX_TEXT_LENGTH,"Your IP %s is in range of %i.%i.*.* -> BANNED!",IP,g_IP_Range_A[i],g_IP_Range_B[i]);
						found=1;
						break;
					}else if(C_Range==g_IP_Range_C[i]){
						if(g_IP_Range_D[i]==-1 || g_IP_Range_D[i]==D_Range){
							snprintf(Text,MAX_TEXT_LENGTH,"Your IP %s is in range of %i.%i.%i.* -> BANNED!",IP,g_IP_Range_A[i],g_IP_Range_B[i],g_IP_Range_C[i]);
							found=1;
							break;
						}
					}
				}
			}
		}
	}
	if(found){
		messageex(User,Text,print_console);
		snprintf(Status,MAX_NAME_LENGTH,"BANNED");
		//ban(User, 0, bBanByID);
	}else{
		snprintf(Status,MAX_NAME_LENGTH,"OK");
	}
	snprintf(Text,MAX_TEXT_LENGTH,"%s: %s <%s> <%s> - %s",ST, User,SteamID,IP,Status);
	writefile(g_BanFile,Text,-1);
}
		
seperate_ip(IP[],&iA,&iB,&iC,&iD){
	new sA[4];
	new sB[4];
	new sC[4];
	new sD[4];
	new sRest[100];
	strsep(IP,".",sA,4,sB,4,sC,4,sD,4,sRest,100);
	if(sA[0]=='*'){
		iA = -1;
	}else{
		iA = strtonum(sA);
	}
	if(sB[0]=='*'){
		iB = -1;
	}else{
		iB = strtonum(sB);
	}
	if(sC[0]=='*'){
		iC = -1;
	}else{
		iC = strtonum(sC);
	}
	if(sD[0]=='*'){
		iD = -1;
	}else{
		iD = strtonum(sD);
	}
}

		
		
		
		
		